-- Kapitel 06 --

-- Abfragen auf einer Tabelle

SELECT Autor, Titel FROM Buch

SELECT DISTINCT Autor FROM Buch

SELECT * FROM Buch ORDER BY Autor, Titel

SELECT * FROM Buch ORDER BY Autor ASC, Erscheinungsjahr DESC

SELECT * FROM CD WHERE Interpret = 'Queen'

SELECT * FROM CD WHERE Interpret = 'Queen' AND Erscheinungsjahr > 1990
SELECT * FROM CD WHERE Interpret = 'Queen' OR Interpret = 'Police'

SELECT * FROM CD WHERE Interpret IN ('Queen', 'Police')

SELECT TOP 10 PERCENT *
FROM CDTrack

SELECT TOP 3 *
FROM CD
ORDER BY Erscheinungsjahr DESC

SET ROWCOUNT 5
SELECT * FROM CDTrack

SET ROWCOUNT 0
SELECT * FROM CDTrack

-- Aggregierungsfunktionen und Gruppierungen

SELECT COUNT(*) FROM Buch WHERE Auflage IS NOT NULL
SELECT COUNT(Auflage) FROM Buch

SELECT COUNT(*) AS AnzahlBuecher 
FROM Buch

SELECT COUNT(*) AS Anzahl, Autor 
FROM Buch 
GROUP BY Autor

SELECT COUNT(*) AS Anzahl, Autor 
FROM Buch 
GROUP BY Autor
HAVING COUNT(*)>1

-- Abfragen auf mehreren Tabellen

SELECT *
FROM CD INNER JOIN CDTrack ON CD.ID = CDTrack.idCD

SELECT CD.*, CDTrack.TrackNr, CDTrack.Titel
FROM CD INNER JOIN CDTrack ON CD.ID = CDTrack.idCD

SELECT CD.*, CDT.TrackNr, CDT.Titel
FROM CD INNER JOIN CDTrack as CDT ON CD.ID = CDT.idCD

SELECT CD.*, CDT.TrackNr, CDT.Titel
FROM CD LEFT JOIN CDTrack as CDT ON CD.ID = CDT.idCD

SELECT Titel, Interpret, Erscheinungsjahr FROM CD
UNION SELECT Titel, Autor, Erscheinungsjahr FROM Buch
UNION SELECT Titel, Produzent, Erscheinungsjahr FROM DVD

SELECT Titel, Interpret AS InterpretAutorProduzent, Erscheinungsjahr, 'CD' as Quelle FROM CD
UNION SELECT Titel, Autor, Erscheinungsjahr, 'Buch' FROM Buch
UNION SELECT Titel, Produzent, Erscheinungsjahr, 'DVD' FROM DVD

SELECT Titel, Interpret AS InterpretAutorProduzent, Erscheinungsjahr, 'CD' as Quelle FROM CD
UNION ALL SELECT Titel, Autor, Erscheinungsjahr, 'Buch' FROM Buch
UNION ALL SELECT Titel, Produzent, Erscheinungsjahr, 'DVD' FROM DVD

-- INSERT INTO

INSERT INTO Buch (Autor, Titel, Hardcover)
VALUES ('Robert Panther', 'Programmieren mit dem .NET Compact Framework', 1)

INSERT INTO CD (Titel)
SELECT Titel FROM DVD

-- SELECT INTO

SELECT * 
INTO MeineBuecher
FROM Buch
WHERE Autor = 'Robert Panther'

SELECT CD.*, CDT.TrackNr, CDT.Titel as TrackTitel
INTO CDMitTracks
FROM CD LEFT JOIN CD_Track as CDT ON CD.ID = CDT.idCD

-- UPDATE

UPDATE MeineBuecher
SET Verlag = '(unbekannt)'
WHERE Verlag IS NULL

UPDATE MeineBuecher
SET Seiten = Seiten + 4

UPDATE MeineBuecher
SET Sprache='deutsch', Hardcover=1
WHERE Titel='Programmieren mit dem .NET Compact Framework'

-- DELETE

DELETE FROM MeineBuecher
WHERE Hardcover=1

-- TRUNCATE TABLE

TRUNCATE TABLE MeineBuecher

-- Sichten

CREATE VIEW dbo.VW_CDsAb2005 AS
SELECT ID, Titel, Erscheinungsjahr
FROM dbo.CD
WHERE (Erscheinungsjahr > 2004)

DROP VIEW dbo.VW_CDsAb2005

GO

CREATE VIEW dbo.VW_CDsAb2005 AS
SELECT ID, Titel, Interpret, Erscheinungsjahr
FROM dbo.CD
WHERE (Erscheinungsjahr > 2004)

ALTER VIEW dbo.VW_CDsAb2005 AS
SELECT ID,Titel, Interpret, Erscheinungsjahr
FROM dbo.CD
WHERE (Erscheinungsjahr > 2004)

--

SELECT * FROM VW_CDsAb2005

SELECT ID, Titel, Interpret, Erscheinungsjahr
FROM dbo.CD
WHERE (Erscheinungsjahr > 2004)

SELECT * 
FROM VW_CDsAb2005
WHERE (Erscheinungsjahr < 2008)

SELECT * 
FROM VW_CDsAb2005 AS CD05
INNER JOIN dbo.CD_Track AS TRK ON CD05.ID=TRK.idCD

SELECT CD05.*, TRK.Titel as TrackTitel, TRK.Interpret as TrackInterpret
FROM VW_CDsAb2005 AS CD05
INNER JOIN dbo.CD_Track AS TRK ON CD05.ID=TRK.idCD

--

INSERT INTO VW_CDsAb2005 (Interpret, Titel, Erscheinungsjahr)
VALUES ('Erwin Mustermann', 'Best Of Erwin Mustermann', 2003)

ALTER VIEW dbo.VW_CDsAb2005 AS
SELECT ID,Titel, Interpret, Erscheinungsjahr
FROM dbo.CD
WHERE (Erscheinungsjahr > 2004)
WITH CHECK OPTION 

--

ALTER VIEW dbo.VW_AktuelleCDs
AS
SELECT TOP (100) PERCENT dbo.CD.ID, dbo.CD.Titel, dbo.CD.Interpret, dbo.CD.AnzahlCDs, dbo.CD.Erscheinungsjahr, dbo.CD.Bewertung, dbo.CD_Track.CDNr, 
	dbo.CD_Track.TrackNr, dbo.CD_Track.Titel AS TrackTitel, dbo.CD_Track.Interpret AS TrackInterpret, dbo.CD_Track.Dauer, 
	dbo.CD_Track.Bewertung AS TrackBewertung, dbo.CD.Kategorie
FROM dbo.CD
	INNER JOIN dbo.CD_Track ON dbo.CD.ID = dbo.CD_Track.idCD
WHERE dbo.CD.Erscheinungsjahr > 2000
ORDER BY dbo.CD.Titel

select * from VW_AktuelleCDs

DELETE FROM VW_AktuelleCDs WHERE ID=2

INSERT INTO VW_AktuelleCDs (Interpret, Titel, Erscheinungsjahr)
VALUES ('Erwin Mustermann', 'The Very Best Of Erwin Mustermann', 2007)

INSERT INTO VW_AktuelleCDs (TrackTitel)
VALUES ('SingSang')

UPDATE VW_AktuelleCDs
SET Bewertung=1 WHERE ID=3
-- setzt die Bewertung fr die CD

UPDATE VW_AktuelleCDs
SET TrackBewertung=1 where ID=3
-- setzt die Bewertung fr die CD-Tracks

UPDATE VW_AktuelleCDs
SET Bewertung=1, TrackBewertung=1 where ID=3
-- Fehler!

UPDATE VW_AktuelleCDs
SET TrackBewertung=Bewertung
WHERE TrackBewertung IS NULL
