-- Kapitel 10 --

-- 10.2 Verwalten von Datenbanken

CREATE DATABASE CrashTestDummy ON  PRIMARY 
( NAME = N'CrashTestDummy', FILENAME = N'c:\Temp\CrashTestDummy.mdf' , SIZE = 20480KB , FILEGROWTH = 10%)
 LOG ON 
( NAME = N'CrashTestDummy_log', FILENAME = N'c:\Temp\CrashTestDummy_log.ldf' , SIZE = 10240KB , FILEGROWTH = 10%)
GO

ALTER DATABASE CrashTestDummy SET COMPATIBILITY_LEVEL = 100
GO
ALTER DATABASE CrashTestDummy SET COMPATIBILITY_LEVEL = 110
GO

ALTER DATABASE CrashTestDummy SET READ_ONLY
GO
ALTER DATABASE CrashTestDummy SET READ_WRITE 
GO

ALTER DATABASE CrashTestDummy SET SINGLE_USER
GO
ALTER DATABASE CrashTestDummy SET MULTI_USER 
GO

ALTER DATABASE CrashTestDummy COLLATE French_CI_AI
GO

ALTER DATABASE CrashTestDummy MODIFY NAME = CrashDummy
GO

DROP DATABASE CrashDummy
DROP DATABASE CrashTestDummy
GO

-- 10.3. Verwalten von Datenbankobjekten

USE MediaBase

-- Tabellen

CREATE TABLE dbo.Adresse
(ID int IDENTITY(1,1) NOT NULL,
Name varchar(80) NOT NULL,
Strasse varchar(80) NULL,
PLZ char(5) NULL,
Wohnort varchar(80) NULL,
CONSTRAINT PK_Adresse PRIMARY KEY (ID))
GO

ALTER TABLE dbo.Adresse ADD Geburtstag datetime
GO

ALTER TABLE dbo.CD_Track 
DROP CONSTRAINT FK_CD_Track_CD
GO

ALTER TABLE dbo.CD_Track
WITH CHECK ADD  CONSTRAINT FK_CD_Track_CD
FOREIGN KEY(idCD)
REFERENCES dbo.CD(ID)
GO

DROP TABLE dbo.Adresse
GO

-- Indizes

CREATE INDEX IX_VerlagErscheinungsjahrAutorTitel
ON dbo.Buch (Verlag, Erscheinungsjahr, Autor, Titel)

ALTER INDEX ALL ON dbo.Buch REORGANIZE
ALTER INDEX ALL ON dbo.Buch REBUILD

DROP INDEX IX_VerlagErscheinungsjahrAutorTitel ON dbo.Buch

-- Sichten, Funktionen, gespeicherte Prozeduren und Trigger

CREATE VIEW dbo.VW_Dummy AS SELECT * FROM dbo.Buch WHERE Erscheinungsjahr > 1980
GO

ALTER VIEW dbo.VW_Dummy AS SELECT * FROM dbo.Buch WHERE Erscheinungsjahr > 1990
GO

DROP VIEW dbo.VW_Dummy
GO

-- DDL-Trigger

CREATE TRIGGER TRG_Datenbank ON DATABASE
FOR DDL_DATABASE_LEVEL_EVENTS
AS
BEGIN
	PRINT 'Datenbank-nderung!'
	INSERT INTO MediaBase.dbo.DDLAenderungsLog (Aenderung) VALUES (EVENTDATA())
END
GO

CREATE VIEW dbo.VW_EinBuch 
AS SELECT TOP 1 * FROM dbo.Buch
GO

DROP VIEW dbo.VW_EinBuch 
GO

SELECT * FROM dbo.DDLAenderungsLog

DROP TRIGGER TRG_Datenbank ON DATABASE
